{-
The Simplest Math Problem No One Can Solve - Collatz Conjecture
https://youtu.be/094y1Z2wpJg
-}

import           Control.Parallel.Strategies (parMap, rdeepseq, rpar)
import           Data.Set                    (fromList)
import           Debug.Trace                 (trace)

main :: IO ()
main = do
  let results =
            parMap rdeepseq f [10^100_000..10^100_000+100] :: [Integer]
  print (fromList results)
-- main = print $ fromList $ dxs
-- main = print $ fromList $ take 300 $ map f [2^100_000..]
  -- fromList [100001,717859]

-- main = print $ fromList $ take 3 $ map f [2^310997..]
-- main = print $ f $ 2^310997 + 2

lst :: [Integer]
lst = take 300 [2^100_000..]

dxs :: [Integer]
dxs = parMap rpar f lst


f :: Integer -> Integer
f n = s 1 n
  where
    s :: Integer -> Integer -> Integer
    s i n
      | n ==    1  = i
      | n ==    0  = i
      | n ==  (-1) = i
      | n ==  (-5) = i
      | n == (-17) = i
      | even n = s (succ i) (n `div` 2)
      | odd  n = s (succ i) (3*n + 1)

f' :: Integer -> Integer
f' n = f'' 1 n
  where
    f'' :: Integer -> Integer -> Integer
    f'' i n'
      | n' ==   1   = t' 0 + t i
      | n' ==   0   = t' 0 + t i
      | n' == (-1 ) = t' 0 + t i
      | n' == (-5 ) = t' 0 + t i
      | n' == (-17) = t' 0 + t i
      | even n' = t $ f'' (succ i) (n' `div` 2)
      | odd  n' = t $ f'' (succ i) (3*n' + 1)
      where t   = trace ("i: " ++ show i ++ ", number: " ++ show n')
            t'  = t'' $ trace ("END: " ++ show n ++ ", length: " <> show i) t''
            t'' = trace "\n#######################################################\n"

-- collatz collect
-- generate the collatz sequence and return it
cc :: Integer -> [Integer]
cc n = cc' [] n
  where
    cc' :: [Integer] -> Integer -> [Integer]
    cc' acc n
      | n ==    1  = acc <>   [1]
      | n ==    0  = acc <>   [0]
      | n ==  (-1) = acc <>  [-1]
      | n ==  (-5) = acc <>  [-5]
      | n == (-17) = acc <> [-17]
      | even n = cc' acc' (n `div` 2)
      | odd  n = cc' acc' (3*n + 1)
      where acc' = acc <> [n]
