-- https://adventofcode.com/2023/day/4
{-# LANGUAGE OverloadedStrings #-}

import           Data.Text    (Text)
import qualified Data.Text    as T
import qualified Data.Text.IO as T


main :: IO ()
main = do
  entries <- T.lines <$> T.readFile "src/advent_of_code/2023/input4"

  putStrLn "Advent of Code 2023 - Day 4"
  -- print entries

  putStrLn ("Part 1: " <> show (solveP1 entries))
  -- putStrLn ("Part 2: " <> show (solveP2 entries))


--
-- Part 1
--

double :: Int -> Int
double = (* 2)

scoreWins :: Int -> Int
scoreWins 0 = 0
scoreWins n = last . take n $ iterate double 1

parse :: Text -> ([Int], [Int])
parse line = (winners, numbers)
  where
    parsed =
      map (map (read . T.unpack)
      . filter (not . T.null)
      . T.splitOn " ")
      . T.splitOn "|"
      . T.drop 2
      . T.dropWhile (/= ':')
      $ line
    winners = head parsed
    numbers = last parsed

scoreTicket :: ([Int], [Int]) -> Int
scoreTicket (winners, numbers) = scoreWins . length
    $ filter (`elem` winners) numbers

solveP1 :: [Text] -> Int
solveP1 = sum . map (scoreTicket . parse)

--
-- Part 2
--


--
-- Examples
--

example :: [Text]
example =
  [ "Card 1: 41 48 83 86 17 | 83 86  6 31 17  9 48 53"
  , "Card 2: 13 32 20 16 61 | 61 30 68 82 17 32 24 19"
  , "Card 3:  1 21 53 59 44 | 69 82 63 72 16 21 14  1"
  , "Card 4: 41 92 73 84 69 | 59 84 76 51 58  5 54 83"
  , "Card 5: 87 83 26 28 32 | 88 30 70 12 93 22 82 36"
  , "Card 6: 31 18 13 56 72 | 74 77 10 23 35 67 36 11"
  ]
