{-
https://projecteuler.net/problem=3

The prime factors of 13195 are 5, 7, 13, and 29.

What is the largest prime factor of the number 600851475143?
-}
module Main where

import           Math.NumberTheory.Primes (Prime (unPrime),
                                           UniqueFactorisation (factorise),
                                           primes)

main :: IO ()
main = print ans

ans :: Int
ans = last $ filter (isFactor bigNum) primes'

primes' :: [Int]
primes' = takeWhile (< sqrt') $ map unPrime primes
  where
    sqrt' = floor $ sqrt (toEnum bigNum)

bigNum :: Int
bigNum = 600851475143

isFactor :: Int -> Int -> Bool
isFactor x n = x `rem` n == 0

ans' :: [Int]
ans' = map (unPrime . fst) $ factorise (fromEnum bigNum)
-- [(Prime 71,1),(Prime 839,1),(Prime 1471,1),(Prime 6857,1)]
-- [71,839,1471,6857]
